
/**
 * ControlP5 ControlWindow
 * by andreas schlegel, 2009
 */
 
import controlP5.*;

ControlP5 CP5;
 
ControlWindow controlWindow;
 
CheckBox checkbox;
CheckBox checkbox1;
CheckBox checkbox2;
CheckBox checkbox3;
CheckBox checkbox4;
CheckBox checkbox5;
CheckBox checkbox6;
CheckBox checkbox7;
CheckBox checkbox8;
CheckBox checkbox9;
CheckBox checkbox10;
CheckBox checkbox11;
CheckBox checkbox12;
 
Textarea myTextarea;
 
int myColorBackground;
int i3 = -1;
 
void setup()
{
    size(1300, 750);
    gettinginput();		//gets input from external file input.txt
    initialadjacency();		//function calculates initial adjacency pairs
    groups();			//obtains number of required groups and their members
    setup1();
 
}
 
void setup1()
{
 
    CP5 = new ControlP5(this);
    CP5.setAutoDraw(false);
    controlWindow = CP5.addControlWindow("controlP5window", 100, 100, 650, 650);
    controlWindow.hideCoordinates();
 
    myTextarea = CP5.addTextarea("label1", "Sub-rectangles", 10, 5, 100, 30);
    myTextarea.moveTo(controlWindow);
 
    for (int i = 0; i < n / 2 + 1; i = i + 1) {
	myTextarea = CP5.addTextarea("label1", rectangles[i] + "(" + (i + 1) + ")  ", 37 * i + 10, 18, 100, 30);
	myTextarea.moveTo(controlWindow);
    }
 
    for (int i = n / 2 + 1; i < n; i = i + 1) {
	myTextarea = CP5.addTextarea("label1", rectangles[i] + "(" + (i + 1) + ")  ", 45 * (i - (n / 2 + 1)) + 10, 31, 100, 30);
	myTextarea.moveTo(controlWindow);
    }
 
    myTextarea = CP5.addTextarea("label1", "GROUPS", 10, 50, 100, 30);
    myTextarea.moveTo(controlWindow);
 
    for (int i = 0; i < no_Groups; i = i + 1) {
	myTextarea = CP5.addTextarea("label1", "Group " + (i + 1) + ": ", 10, 63 + 12 * i, 100, 30);
	myTextarea.moveTo(controlWindow);
	for (int j4 = 0; j4 < (v[i + 1] - v[i]); j4 = j4 + 1) {
	    myTextarea = CP5.addTextarea("label1", rectangles[members_grp[i][j4]] + " ", 15 + (j4 + 1) * 40, 63 + 12 * i, 100, 30);
	    myTextarea.moveTo(controlWindow);
	}
    }
 
    myTextarea = CP5.addTextarea(
  "label1", "NOTE: "+
  "There are 13 rows where a click is must. Therefore, click in each row in the top-down order.",10,132,450,60);
  myTextarea.moveTo(controlWindow);
  
   myTextarea = CP5.addTextarea(
  "label1", "Sub-rectangle Transfer\n"+
  "If you want to move a sub-rectangle from a group A to a group B, then click for group number for groups A & B" + 
  " and then for sub-rectangle number" + " (sub-rectangle number and group number are given above)." +
  " If you do not want to move any sub-rectangle, click at 0 for sub-rectangle number.",10,172,450,60);
   myTextarea.moveTo(controlWindow);
 
    myTextarea = CP5.addTextarea("label1", "1. Group A", 10, 235, 60, 20);
    myTextarea.moveTo(controlWindow);
    myTextarea = CP5.addTextarea("label1", "2. Group B", 10, 257, 60, 20);
    myTextarea.moveTo(controlWindow);
    myTextarea = CP5.addTextarea("label1", "3. Rectangle No.", 10, 278, 60, 20);
    myTextarea.moveTo(controlWindow);
 
    myTextarea = CP5.addTextarea("label1", "POSITION OF GROUPS\n" + 
    "Choose position of each group one by one by clicking only once " + 
    "in each row and each column.", 10, 305, 400, 70);
    myTextarea.moveTo(controlWindow);
 
    myTextarea = CP5.addTextarea("label1", "4. CENTRE", 10, 346, 50, 20);
    myTextarea.moveTo(controlWindow);
 
    myTextarea = CP5.addTextarea("label1", "5. LEFT", 10, 368, 40, 20);
    myTextarea.moveTo(controlWindow);
 
    myTextarea = CP5.addTextarea("label1", "6. ABOVE", 10, 390, 50, 20);
    myTextarea.moveTo(controlWindow);
 
    myTextarea = CP5.addTextarea("label1", "7. RIGHT", 10, 410, 50, 20);
    myTextarea.moveTo(controlWindow);
 
    myTextarea = CP5.addTextarea("label1", "8. BELOW", 10, 430, 50, 20);
    myTextarea.moveTo(controlWindow);
 
    myTextarea = CP5.addTextarea("label1", "SPIRALS\n" + "Choose SPIRAL for each group " + 
    "one by one by clicking only once in each row.", 10, 465, 300, 70);
    myTextarea.moveTo(controlWindow);
 
    myTextarea = CP5.addTextarea("label1", "9. CENTRE Gr", 10, 515, 70, 20);
    myTextarea.moveTo(controlWindow);
 
    myTextarea = CP5.addTextarea("label1", "10. LEFT Gr", 10, 537, 70, 20);
    myTextarea.moveTo(controlWindow);
 
    myTextarea = CP5.addTextarea("label1", "11. ABOVE Gr", 10, 559, 70, 20);
    myTextarea.moveTo(controlWindow);
 
    myTextarea = CP5.addTextarea("label1", "12. RIGHT Gr", 10, 580, 70, 20);
    myTextarea.moveTo(controlWindow);
 
    myTextarea = CP5.addTextarea("label1", "13. BELOW Gr", 10, 600, 70, 20);
    myTextarea.moveTo(controlWindow);
 
    checkbox1 = CP5.addCheckBox("checkBox", 70, 345);
    checkbox1.moveTo(controlWindow);
    checkbox2 = CP5.addCheckBox("checkBox", 70, 367);
    checkbox2.moveTo(controlWindow);
    checkbox3 = CP5.addCheckBox("checkBox", 70, 389);
    checkbox3.moveTo(controlWindow);
    checkbox4 = CP5.addCheckBox("checkBox", 70, 410);
    checkbox4.moveTo(controlWindow);
    checkbox5 = CP5.addCheckBox("checkBox", 70, 430);
    checkbox5.moveTo(controlWindow);
 
    checkbox = CP5.addCheckBox("checkBox", 90, 515);
    checkbox.moveTo(controlWindow);
    checkbox6 = CP5.addCheckBox("checkBox", 90, 537);
    checkbox6.moveTo(controlWindow);
    checkbox7 = CP5.addCheckBox("checkBox", 90, 559);
    checkbox7.moveTo(controlWindow);
    checkbox8 = CP5.addCheckBox("checkBox", 90, 580);
    checkbox8.moveTo(controlWindow);
    checkbox9 = CP5.addCheckBox("checkBox", 90, 600);
    checkbox9.moveTo(controlWindow);
    checkbox10 = CP5.addCheckBox("checkBox", 70, 235);
    checkbox10.moveTo(controlWindow);
    checkbox11 = CP5.addCheckBox("checkBox", 70, 257);
    checkbox11.moveTo(controlWindow);
    checkbox12 = CP5.addCheckBox("checkBox", 70, 278);
    checkbox12.moveTo(controlWindow);
 
    checkbox1.setItemsPerRow(5);
    checkbox2.setItemsPerRow(5);
    checkbox3.setItemsPerRow(5);
    checkbox4.setItemsPerRow(5);
    checkbox5.setItemsPerRow(5);
    checkbox1.setSpacingColumn(10);
    checkbox2.setSpacingColumn(10);
    checkbox3.setSpacingColumn(10);
    checkbox4.setSpacingColumn(10);
    checkbox5.setSpacingColumn(10);
 
    checkbox1.addItem("1", 0);
    checkbox1.addItem("2", 1);
    checkbox1.addItem("3", 2);
    checkbox1.addItem("4", 3);
    checkbox1.addItem("5", 4);
 
    checkbox2.addItem("1", 0);
    checkbox2.addItem("2", 1);
    checkbox2.addItem("3", 2);
    checkbox2.addItem("4", 3);
    checkbox2.addItem("5", 4);
    checkbox3.addItem("1", 0);
    checkbox3.addItem("2", 1);
    checkbox3.addItem("3", 2);
    checkbox3.addItem("4", 3);
    checkbox3.addItem("5", 4);
    checkbox4.addItem("1", 0);
    checkbox4.addItem("2", 1);
    checkbox4.addItem("3", 2);
    checkbox4.addItem("4", 3);
    checkbox4.addItem("5", 4);
    checkbox5.addItem("1", 0);
    checkbox5.addItem("2", 1);
    checkbox5.addItem("3", 2);
    checkbox5.addItem("4", 3);
    checkbox5.addItem("5", 4);
 
    checkbox.setItemsPerRow(8);
    checkbox6.setItemsPerRow(8);
    checkbox7.setItemsPerRow(8);
    checkbox8.setItemsPerRow(8);
    checkbox9.setItemsPerRow(8);
    checkbox10.setItemsPerRow(5);
    checkbox11.setItemsPerRow(5);
    checkbox12.setItemsPerRow(17);
 
    checkbox.setSpacingColumn(10);
    checkbox6.setSpacingColumn(10);
    checkbox7.setSpacingColumn(10);
    checkbox8.setSpacingColumn(10);
    checkbox9.setSpacingColumn(10);
    checkbox10.setSpacingColumn(10);
    checkbox11.setSpacingColumn(10);
    checkbox12.setSpacingColumn(10);
 
    // add items to a checkbox.
    checkbox.addItem("1", 0);
    checkbox.addItem("2", 1);
    checkbox.addItem("3", 2);
    checkbox.addItem("4", 3);
    checkbox.addItem("5", 4);
    checkbox.addItem("6", 5);
    checkbox.addItem("7", 6);
    checkbox.addItem("8", 7);
    checkbox6.addItem("1", 0);
    checkbox6.addItem("2", 1);
    checkbox6.addItem("3", 2);
    checkbox6.addItem("4", 3);
    checkbox6.addItem("5", 4);
    checkbox6.addItem("6", 5);
    checkbox6.addItem("7", 6);
    checkbox6.addItem("8", 7);
    checkbox7.addItem("1", 0);
    checkbox7.addItem("2", 1);
    checkbox7.addItem("3", 2);
    checkbox7.addItem("4", 3);
    checkbox7.addItem("5", 4);
    checkbox7.addItem("6", 5);
    checkbox7.addItem("7", 6);
    checkbox7.addItem("8", 7);
    checkbox8.addItem("1", 0);
    checkbox8.addItem("2", 1);
    checkbox8.addItem("3", 2);
    checkbox8.addItem("4", 3);
    checkbox8.addItem("5", 4);
    checkbox8.addItem("6", 5);
    checkbox8.addItem("7", 6);
    checkbox8.addItem("8", 7);
    checkbox9.addItem("1", 0);
    checkbox9.addItem("2", 1);
    checkbox9.addItem("3", 2);
    checkbox9.addItem("4", 3);
    checkbox9.addItem("5", 4);
    checkbox9.addItem("6", 5);
    checkbox9.addItem("7", 6);
    checkbox9.addItem("8", 7);
    checkbox10.addItem("1", 0);
    checkbox10.addItem("2", 1);
    checkbox10.addItem("3", 2);
    checkbox10.addItem("4", 3);
    checkbox10.addItem("5", 4);
    checkbox11.addItem("1", 0);
    checkbox11.addItem("2", 1);
    checkbox11.addItem("3", 2);
    checkbox11.addItem("4", 3);
    checkbox11.addItem("5", 4);
    checkbox12.addItem("0", -1);
    checkbox12.addItem("1", 0);
    checkbox12.addItem("2", 1);
    checkbox12.addItem("3", 2);
    checkbox12.addItem("4", 3);
    checkbox12.addItem("5", 4);
    checkbox12.addItem("6", 5);
    checkbox12.addItem("7", 6);
    checkbox12.addItem("8", 7);
    checkbox12.addItem("9", 8);
    checkbox12.addItem("10", 9);
    checkbox12.addItem("11", 10);
    checkbox12.addItem("12", 11);
    checkbox12.addItem("13", 12);
    checkbox12.addItem("14", 13);
    checkbox12.addItem("15", 14);
    checkbox12.addItem("16", 15);
 
    controlWindow.setTitle("GUI");
 
}
 
void draw()
{
 
}
 
void controlEvent(ControlEvent theEvent)
{
    if (theEvent.isGroup()) {
	myColorBackground = 0;
	// print("got an event from "+theEvent.group().name()+"t");
	// checkbox uses arrayValue to store the state of 
	// individual checkbox-items. usage:
	for (int i = 0; i < theEvent.group().arrayValue().length; i++) {
	    int n = (int) theEvent.group().arrayValue()[i];

	    if (n == 1) {
		myColorBackground = int (((RadioButton) theEvent.group()).getItem(i).internalValue());
		//println(myColorBackground);
 
	    }
	}

	i3++;

	if (i3 < 3) {
	    change1[i3] = myColorBackground;
	}
	if (i3 > 2 && i3 < 8)
	    Grnumber[i3 - 3] = myColorBackground;
	if (i3 > 7)
	    spiral[i3 - 8] = myColorBackground;
 
    }
    
    if (i3 == 2) {
	changingrectangle();	//change location of any rectangle from one group to other
	arrangingsizes();
    }
    
    if (i3 == 12) {
    plusshapedframe();		//gives plus shaped frame with outer plot
    adjacencypairs();		//obtains final adjacency pairs
    adjacencymatrix();		//obtains adjacency matrix, degree of all rectangles
    eigenvalue();		//gives eigen values and characteristic function of adjacency matrix
    drawinggraph();		//draws graph
    distance();			//gives distance and shortest path between all rectangles
    cutvertex();		//gives cut vertex and pair cut vertex of graph
    eccentricity();		//gives eccentricites of all rectangles, radius, diameter and center
    momentofinertia();		//gives 1st order moment and moment of inertia of all rectangles
    print();			//print all results in external file Output.txt, obtains chromatic number of obtained graph
                                // and check graph is bipartite or not

//prints following things on the screen
    PFont myFont = createFont("Times", 24);
    textFont(myFont);
    text("General Solution ", 180, 30);
    text("Graph ", 800, 25);
    PFont myFont1 = createFont("Times", 20);
    textFont(myFont1);
    text("Total Area = " + nf(totalarea, 0, 2), 10, 590);
    text("Area of C & T = " + nf((totalarea - area_rects), 0, 2), 10, 620);
    text("Max(MOI) = " + nf(MOI1[1], 0, 2), 10, 650);
    text("Min(MOI) = " + nf(MOI1[n], 0, 2), 10, 680);
    text("Diameter = " + int (eccentricity1[1]), 1000, 600);
    text("Radius = " + int (eccentricity1[n]), 1000, 630);
    text("Spirals Used: " + spiral[0] + ", " + spiral[1] + ", " + spiral[2] + ", " + spiral[3] + ", " + spiral[4], 600, 650);
    //save the screen as .jpg file
    saveFrame("allocation-0000.jpg"); 
    }
}
